#!/usr/bin/env python

# Ref: https://github.com/pytorch/tutorials/blob/master/intermediate_source/dist_tuto.rst
# (Pytorch Distributed Tutorial)

import torch.nn as nn
import torch.nn.functional as F


class MNIST_CNN(nn.Module):
  """ CNN Network architecture for MNIST only """

  def __init__(self):
    super(MNIST_CNN, self).__init__()
    # TODO: implement this as you want
    pass

  def forward(self, x):
    # TODO: implement this as you want
    pass


class MNIST_CONVEX(nn.Module):
  """Convex network"""

  def __init__(self):
    super(MNIST_CONVEX, self).__init__()
    self.fc = nn.Linear(28 * 28, 10)

  def forward(self, x):
    x = x.reshape(-1, 28 * 28)
    x = self.fc(x)
    return F.log_softmax(x, dim=1)


class CIFAR10_CNN(nn.Module):
  """Sample CNN network for CIFAR10"""

  def __init__(self):
    super(CIFAR10_CNN, self).__init__()
    # TODO: implement this as you want
    pass

  def forward(self, x):
    # TODO: implement this as you want
    pass


class CIFAR10_CONVEX(nn.Module):
  """Convex network including only 2 FCs"""

  def __init__(self):
    super(CIFAR10_CONVEX, self).__init__()
    self.fc = nn.Linear(32 * 32 * 3, 100)
    self.fc2 = nn.Linear(100, 10)

  def forward(self, x):
    x = x.reshape(-1, 32 * 32 * 3)
    x = self.fc(x)
    x = self.fc2(x)
    return F.log_softmax(x, dim=1)


class Logistic_Real(nn.Module):
  def __init__(self, n_attributes, n_classes):
    super(Logistic_Real, self).__init__()
    self.fc = nn.Linear(n_attributes, n_classes)

  def forward(self, x):
    x = self.fc(x)
    return F.log_softmax(x, dim=1)


class Regression_Real(nn.Module):
  def __init__(self, n_attributes):
    super(Regression_Real, self).__init__()
    self.fc = nn.Linear(n_attributes, 1)

  def forward(self, x):
    x = self.fc(x)
    return x
